#include "contacts.h"
#include "ui_contacts.h"
#include "message.h"
#include <QtMessaging/QMessage>
#include <QtMessaging/QMessageManager>
#include <QtMessaging/QMessageService>
#include <QtMessaging/QMessageContentContainer>
#include <QtGlobal>
#include <QtDebug>
#include <QList>
#include <QHeaderView>

#include <QListWidget>
#include <QListWidgetItem>
#include <QTableWidget>

Contacts::Contacts(QWidget *parent, Message *mwi) :
        QWidget(parent),
        ui(new Ui::Contacts)
{
    ui->setupUi(this);
    mw = mwi;



    connect(ui->ButtonGetMessage, SIGNAL(clicked()),
                        parent, SLOT(changeViewToMessage()));

    connect(ui->listWidget_2, SIGNAL(itemClicked(QListWidgetItem *)),
            this, SLOT (translateExistingMessage(QListWidgetItem *)));
}

Contacts::~Contacts(){
    delete ui;
}

void Contacts::listContacts(){

    m_manager = new QMessageManager(this);
        QMessageIdList list = m_manager->queryMessages(QMessageFilter::byType(QMessage::Sms));
        qDebug() << list.count();
        if (list.size() == 0) {
            qDebug() << "No messages (" << list.count() << ")";
        } else {
            for (int i = 0; i < list.size(); ++i) {
                     QMessageId id = list.at(i);
                     QMessage message = m_manager->message(id);
                     QString sender= mw->getSender(&message);
                     QString inserttext = "Sender: " + sender;
                     ui->listWidget_2->insertItem(i,inserttext);
                     QListWidgetItem *item = ui->listWidget_2->item(i);
                     item->setData(Qt::UserRole, QVariant::fromValue<QMessageId>(id));
            qDebug() << "Message number (" << i << message.textContent() << ")";
            }



    }
    delete m_manager;
}

void Contacts::translateExistingMessage(QListWidgetItem *item) {

   m_manager = new QMessageManager(this);
   QMessageIdList list = m_manager->queryMessages(QMessageFilter::byType(QMessage::Sms));
   if (list.size() == 0) {
       qDebug() << "No messages (" << list.count() << ")";
    } else {
        QVariant result = item->data(Qt::UserRole);

        QMessageId id = result.value<QMessageId>() ;
        QMessage message = m_manager->message(id);
        mw->processIncomingSMS(message);

    }
    delete m_manager;
}
