#ifndef MESSAGE_H
#define MESSAGE_H


#include <QWidget>
#include <QtNetwork/QHttp>
#include <QtNetwork/QNetworkAccessManager>
#include <QPointer>
#include <QMessageBox>
#include <QtMessaging/qmessage.h>
#include <QtMessaging/qmessagemanager.h>
#include <QtMessaging/qmessageid.h>
#include <QtContacts/qcontactdetailfilter.h>
#include <QtContacts/qcontactfilter.h>
#include <QtContacts/qcontactphonenumber.h>
#include <QtContacts/QContact>



QTM_USE_NAMESPACE

namespace Ui {
    class Message;
}

class Message :public QWidget
{
    Q_OBJECT


private slots:
    //Rosti
    void on_langBox_1_currentIndexChanged(QString );
    //void on_langBox_2_currentIndexChanged(QString );
    void MakeLink();
    void replyFinished(QNetworkReply*);
    //Send Message
    void processIncomingSMS();

    //Oskar
    //Send message
    void sendMessage();

    // Listening signals from QMessageManager
    void messageAdded(const QMessageId&,
                      const QMessageManager::NotificationFilterIdSet&);


public:
    explicit Message(QWidget *parent);
       ~Message();
       QString getSender(QMessage *message);
        void processIncomingSMS(QMessage);

signals:
       void new_translated_message();
       void create_new_sms(QString, QString, QString);
private:
       void writeSettings();
       void readSettings();
       //orig lang of message
       QString orig_lang;
       //user's lang 1
       QString lang_1;
       //user's lang 2
       //QString lang_2;
       QString origin_message;
       QString number_to;
       QString translated_message;

        Ui::Message *ui;
        QNetworkAccessManager *manager;
        QPointer<QMessageManager> m_manager;
        QMessageManager::NotificationFilterIdSet m_notifFilterSet;
        QMessageId m_messageId;
        QContactManager *contactmanager;
};

#endif // MESSAGE_H
