#include "reply_message.h"
#include "ui_reply_message.h"

#include <QString>
#include <QtWebKit/QWebView>
#include <QByteArray>
#include <QtNetwork/QHttp>
#include <QtNetwork/QHttpRequestHeader>
#include <QFile>
#include <iostream>
#include <QtNetwork/QNetworkAccessManager>
#include <QtNetwork/QNetworkReply>
#include <QMessage>
#include <QtMessaging/QMessageManager>
#include <QtMessaging/QMessageFilter>
#include <QtMessaging/QMessageService>
#include <QtContacts/qcontactmanager.h>
#include <QtGlobal>
#include <QtDebug>
#include <QContactFilter>
#include <QContactDetailFilter>
#include <qtimer.h>
#include <QSettings>



Reply_Message::Reply_Message(QWidget *parent) :
        QWidget(parent),
        ui(new Ui::Reply_Message)
{
    ui->setupUi(this);

    manager = new QNetworkAccessManager(this);

    //connect(ui->ButtonSendMessage, SIGNAL(clicked()),
    //        this, SLOT(send_message()));
    //request if fully received
    connect(manager, SIGNAL(finished(QNetworkReply*)),
            this, SLOT(translate_message(QNetworkReply*)));
    connect(ui->ButtonSendMessage, SIGNAL(clicked()),
            this, SLOT(send_request()));

    connect(this, SIGNAL(message_sent()),
            parent, SLOT(HideApplication()));


}

Reply_Message::~Reply_Message(){
    delete ui;
}


void Reply_Message::send_message()
{


    //message = ui->Field_Message->text();
    QString address = number;
    QMessage sms_message;
    sms_message.setType(QMessage::Sms);
    sms_message.setTo(QMessageAddress(QMessageAddress::System, address));
    sms_message.setBody(message);
    QMessageService* service = new QMessageService(this);
    if (service->send(sms_message)) {
        qDebug() << "Sended SMS to" << address  << message;
        emit message_sent();
    }
}

void Reply_Message::reload_gui()
{
    //ui->Field_Lang_From->setText(lang_from);
    //ui->Field_Lang_To->setText(lang_to);
    ui->Field_To->setText(number);
    ui->langBox_From->setCurrentIndex(ui->langBox_From->findText(lang_from, Qt::MatchExactly));
    ui->langBox_To->setCurrentIndex(ui->langBox_To->findText(lang_to, Qt::MatchExactly));


}

void Reply_Message::send_request()
{
    //if (origin_message.length() != 0)
    message = ui->Field_Message->toPlainText();
    //message = ui->Field_Message->content();
    //message = ui->Field_Message->text();
    //{
    //lang_to = "de";
        QString link = "http://translate.google.com/?hl=en&ie=UTF8&text=" + message + "&langpair="+ lang_from + "|"+ lang_to;
        //qDebug() << "link: " << link;
        manager->get(QNetworkRequest(QUrl(link)));
    //}
}

void Reply_Message::translate_message(QNetworkReply *my_reply)
{
    //ui->Field_Translation->setText("");
    //ui->Field_Translation->setText("Reply Finnished");
    //read reply to buffer
    QString my_string = my_reply->readAll();
    //QString size_of_buffer;
   // size_of_buffer.setNum(my_string.size());
    //qDebug() << "Received: " << size_of_buffer;

    //ui->Field_Translation->append("Chars received: " + size_of_buffer);

    //split source code
    if (my_string.contains("this.style.backgroundColor='#fff'\">"))
    //if (my_string.contains("bird"))

    {
        //qDebug() << "Bird found!!!!!!";

        //emit new_translated_message();



        QStringList mylist = my_string.split("this.style.backgroundColor='#fff'\">");
        //QStringList mylist = my_string.split("this.style.backgroundColor='#fff'\">", QString::SkipEmptyParts);

        //split source code
        QString temp_string = mylist[0];

        temp_string.setNum(temp_string.size());
        QString temp_new_string = mylist[1];



        QStringList my_list_2 = mylist[1].split("</span>", QString::SkipEmptyParts);
        //Return of module my_list_2[0]
//        ui->Field_Translation->append("------>  " + my_list_2[0]);

        //ui->Field_Translation->setText("<font color=\"white\">" + my_list_2[0] + "</font>");
        //ui->Field_Translation->setText(my_list_2[0]);
        message = my_list_2[0];
        //ui->textEdit->setText(my_list_2[0]);


    }
   // else
        //ui->Field_Translation->setText("<font color=\"white\">" + origin_message + "</font>");
        //ui->Field_Translation->setText(origin_message);


    //qDebug() << "Final " << message;

    send_message();


}



void Reply_Message::on_Field_Message_textChanged()
{
    int all_chars = ui->Field_Message->toPlainText().length();
    //int all_chars = ui->Field_Message->text().length();
    //number of messages
    int n_m = all_chars/160;
    //all_chars = 160 - all_chars;
    QString str_all_chars;
    str_all_chars.setNum(160 - all_chars%160);
    QString str_n_m;
    str_n_m.setNum(n_m);



    //integer.setNum(ui->Field_Message->text().length());
    ui->labelAmountOfChars->setText(str_all_chars + "\n("+ str_n_m + ")");

}
