#include "widget.h"
#include "ui_widget.h"
#include "message.h"
#include "contacts.h"
#include "reply_message.h"

Widget::Widget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Widget)
{
    mw = new Message(this);
    cw = new Contacts(this, mw);
    rm = new Reply_Message(this);

    ui->setupUi(this);


    // Listen for send message signal
    connect(ui->ButtonContacts, SIGNAL(clicked()),
            this, SLOT(changeViewToContacts()));

    // Listen for send message signal
    connect(ui->ButtonMessage, SIGNAL(clicked()),
            this, SLOT(changeViewToMessage()));


    //this->show();

}

Widget::~Widget()
{
    delete ui;
}


void Widget::HideApplication()
{
    this->hide();
    mw->hide();
    cw->hide();
    rm->hide();
}

void Widget::changeViewToContacts()
{
    //this->show();
    //mw->hide();
    //cw->show();
    //cw->raise();

    //let's hide all and make it daemon
    //this->hide();
    this->show();
    cw->show();
    mw->hide();
    rm->hide();
    cw->listContacts();

}

void Widget::changeViewToMessage()
{
    this->show();
    //this->setStyleSheet("background-color: black;");
    ui->ButtonContacts->setVisible(false);
    ui->ButtonMessage->setVisible(false);
    //cw->hide();
    //cw->showFullScreen();
    mw->show();
    mw->raise();
    rm->hide();
    cw->hide();
}

void Widget::changeViewToSendMessage()
{
    this->show();
    ui->ButtonContacts->setVisible(false);
    ui->ButtonMessage->setVisible(false);

    rm->show();
    //rm->hide();
    mw->hide();
    cw->hide();



}

void Widget::load_new_sms(QString number, QString lang_from, QString lang_to)
{
    rm->number = number;
    rm->lang_from = lang_from;
    rm->lang_to = lang_to;
    rm->reload_gui();
}


